/* Copyright(C) 2004 Brazil

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _SEN_STORE_H
#define _SEN_STORE_H

#ifndef _SENNA_H
#include "senna_in.h"
#endif /* _SENNA_H */

#ifndef _SEN_SET_H
#include "set.h"
#endif /* _SEN_SET_H */

#ifndef _SEN_IO_H
#include "io.h"
#endif /* _SEN_IO_H */

#ifdef	__cplusplus
extern "C" {
#endif

typedef struct _sen_store_vnode
{
  struct _sen_store_vnode *car;
  struct _sen_store_vnode *cdr;
  sen_id tid;
  sen_id vid;
  int freq;
  int len;
} sen_store_vnode;

struct _sen_store {
  sen_sym *vgram;
};

struct _sen_store_buf {
  size_t len;
  sen_id *tvs;
  sen_id *tvp;
  sen_id *tve;
  sen_store_vnode *vps;
  sen_store_vnode *vpp;
  sen_store_vnode *vpe;
};

sen_store * sen_store_create(const char *path);
sen_store * sen_store_open(const char *path);
sen_rc sen_store_close(sen_store *store);
sen_rc sen_store_update(sen_store *store, sen_id rid, sen_store_buf *b, sen_set *terms);

sen_store_buf * sen_store_buf_open(size_t len);
sen_rc sen_store_buf_add(sen_store_buf *b, sen_id tid);
sen_rc sen_store_buf_close(sen_store_buf *b);

#ifdef __cplusplus
}
#endif

#endif /* _SEN_STORE_H */
